#include <iostream>


/*
  Illustration de la difference entre fonction virtuelles ou non.
  Une fonction virtuelle peut etre masquee par une fonction de meme
  nom existant dans une classe fille.
*/

class A
{
public:
  virtual void f1(void)
  {std::cout << "f1, dans A\n";}
  void f2(void)
  {std::cout << "f2, dans A\n";}
  /*
	La fonction f1 est virtuelle, elle sera donc masquee par une fonction de meme nom dans les classes derivees.
  */

};

class B : public A
{
public: 
  void f1(void)
  {std::cout << "f1, dans B\n";}
  void f2(void)
  {std::cout << "f2, dans B\n";}
};

  

int main(void)
{
  A a;
  a.f1();
  a.f2();

  std::cout << std::endl;
  
  B b;
  b.f1();
  b.f2();

  std::cout << std::endl;
  
  A *b_comme_A = &b;
  b_comme_A->f1();
  b_comme_A->f2();
  
  
  return 0;
}
