#include "alea.hpp"
#include <cmath>
#include <iostream>




/*
  Une classe correspondant aux variables exponentielles de parametre lambda.
*/

class expo : public va_reelle
{
private:
  double lambda;
public:
  expo(double l=1) : lambda(l) {};
  
  double operator() (void) const
  {
	return -log(unif01())/lambda;
  }

  double param(void) const
  {return lambda;}
  
};
  


int main(void)
{
  expo X(0.5); // Une variable de loi exponentielle de parametre 0.5

  int n = 10000;
  
  std::cout << "X suit la loi exponentielle de parametre " << X.param() << "\n";
  std::cout << "Par methode de Monte Carlo avec " << n << " tirages, on trouve :\n";
  std::cout << "moyenne de X  : " << X.E(n) << " (valeur theorique : " << 1/X.param() << " )\n";
  std::cout << "variance de X : " << X.V(n) << " (valeur theorique : " << 1/(X.param()*X.param()) << " )\n";
  
  return 0;
}
